Loading...
Searching...
No Matches
stdex::stream::file Class Reference

File-system file. More...

`#include <stdex/stream.hpp>`

Inheritance diagram for stdex::stream::file:

## Public Member Functions

| file (sys_handle h=invalid_handle, state_t state=state_t::ok)
| file (const schar_t *filename, int mode)
| Opens file.
| file (const stdex::sstring &filename, int mode)
| Opens file.
void | open (const schar_t *filename, int mode)
| Opens file.
void | open (const stdex::sstring &filename, int mode)
| Opens file.
virtual fpos_t | seek (foff_t offset, seek_t how=seek_t::beg)
| Seeks to specified relative file position.
virtual fpos_t | tell () const
| Returns absolute file position in file or fpos_max if fails. This method does not update stream state.
virtual void | lock (fpos_t offset, fsize_t length)
| Locks file section for exclusive access.
virtual void | unlock (fpos_t offset, fsize_t length)
| Unlocks file section for exclusive access.
virtual fsize_t | size ()
| Returns file size Should the file size cannot be determined, the method returns fsize_max and it does not reset the state to failed.
virtual void | truncate ()
| Sets file size - truncates the remainder of file content from the current file position to the end of file.
virtual time_point | ctime () const
| Returns file creation time.
virtual time_point | atime () const
| Returns file access time.
virtual time_point | mtime () const
| Returns file modification time.
virtual void | set_ctime (time_point date)
| Sets file create time.
virtual void | set_atime (time_point date)
| Sets file access time.
virtual void | set_mtime (time_point date)
| Sets file modification time.
Public Member Functions inherited from stdex::stream::basic_file
virtual std::vector< uint8_t > | read_remainder (size_t max_length=SIZE_MAX)
| Reads and returns remainder of the stream.
fpos_t | seekbeg (fpos_t offset)
| Seeks to absolute file position.
fpos_t | seekcur (foff_t offset)
| Seeks to relative from current file position.
fpos_t | seekend (foff_t offset)
| Seeks to relative from end file position.
virtual void | skip (fsize_t amount)
| Skips given amount of bytes of data on the stream.
charset_id | read_charset (charset_id default_charset=charset_id::system)
| Attempts to detect textfile charset based on UTF-32, UTF-16 or UTF-8 BOM.
Public Member Functions inherited from stdex::stream::basic
| basic (state_t state=state_t::ok)
state_t | state () const
| Returns stream state after last operation.
bool | ok () const
| Returns true if the stream state is clean i.e. previous operation was succesful.
uint8_t | read_byte ()
| Reads one byte of data.
void | write_byte (uint8_t byte, fsize_t amount=1)
| Writes a byte of data.
template<class T >
basic & | read_data (T &data)
| Reads one primitive data type.
template<class T >
basic & | write_data (const T data)
| Writes one primitive data type.
template<class _Traits = std::char_traits<char>, class _Ax = std::allocator<char>>
size_t | readln (std::basic_string< char, _Traits, _Ax > &str)
| Reads stream to the end-of-line or end-of-file.
template<class _Traits = std::char_traits<wchar_t>, class _Ax = std::allocator<wchar_t>>
size_t | readln (std::basic_string< wchar_t, _Traits, _Ax > &wstr)
| Reads stream to the end-of-line or end-of-file.
template<class T_from , class T_to , class _Traits = std::char_traits<T_to>, class _Ax = std::allocator<T_to>>
size_t | readln (std::basic_string< T_to, _Traits, _Ax > &wstr, charset_encoder< T_from, T_to > &encoder)
| Reads stream to the end-of-line or end-of-file.
template<class _Elem , class _Traits = std::char_traits<_Elem>, class _Ax = std::allocator<_Elem>>
size_t | readln_and_attach (std::basic_string< _Elem, _Traits, _Ax > &str)
| Reads stream to the end-of-line or end-of-file and append to str.
template<class T_from , class T_to , class _Traits = std::char_traits<T_to>, class _Ax = std::allocator<T_to>>
size_t | readln_and_attach (std::basic_string< T_to, _Traits, _Ax > &wstr, charset_encoder< T_from, T_to > &encoder)
| Reads stream to the end-of-line or end-of-file and append to str.
size_t | read_array (_Out_writes_bytes_(size *count) void *array, size_t size, size_t count)
| Reads an array of data from the stream.
size_t | write_array (_In_reads_bytes_opt_(size *count) const void *array, size_t size, size_t count)
| Writes an array of data to the stream.
template<class T_from , class T_to >
size_t | write_array (const T_from *wstr, charset_encoder< T_from, T_to > &encoder)
| Writes array of characters to the stream.
template<class T_from , class T_to >
size_t | write_array (_In_reads_or_z_opt_(num_chars) const T_from *wstr, size_t num_chars, charset_encoder< T_from, T_to > &encoder)
| Writes array of characters to the stream.
template<class T_from , class T_to , class _Traits = std::char_traits<T_from>, class _Ax = std::allocator<T_from>>
size_t | write_array (const std::basic_string< T_from, _Traits, _Ax > &wstr, charset_encoder< T_from, T_to > &encoder)
| Writes array of characters to the stream.
template<class _Elem , class _Traits = std::char_traits<_Elem>, class _Ax = std::allocator<_Elem>>
basic & | read_str (std::basic_string< _Elem, _Traits, _Ax > &data)
| Reads length-prefixed string from the stream.
template<class T >
basic & | write_str (const T *data)
| Writes string to the stream length-prefixed.
template<class _Elem , class _Traits = std::char_traits<_Elem>, class _Ax = std::allocator<_Elem>>
basic & | write_str (const std::basic_string< _Elem, _Traits, _Ax > &data)
| Writes string to the stream length-prefixed.
fsize_t | write_stream (basic &stream, fsize_t amount=fsize_max)
| Writes content of another stream.
void | write_charset (charset_id charset)
| Writes UTF8, UTF-16 or UTF-32 byte-order-mark.
size_t | write_sprintf (_Printf_format_string_params_(2) const char *format, locale_t locale,...)
| Writes formatted string to the stream.
size_t | write_sprintf (_Printf_format_string_params_(2) const wchar_t *format, locale_t locale,...)
| Writes formatted string to the stream.
size_t | write_vsprintf (_Printf_format_string_params_(2) const char *format, locale_t locale, va_list params)
| Writes formatted string to the stream.
size_t | write_vsprintf (_Printf_format_string_params_(2) const wchar_t *format, locale_t locale, va_list params)
| Writes formatted string to the stream.
basic & | operator>> (int8_t &data)
basic & | operator<< (const int8_t data)
basic & | operator>> (int16_t &data)
basic & | operator<< (const int16_t data)
basic & | operator>> (int32_t &data)
basic & | operator<< (const int32_t data)
basic & | operator>> (int64_t &data)
basic & | operator<< (const int64_t data)
basic & | operator>> (uint8_t &data)
basic & | operator<< (const uint8_t data)
basic & | operator>> (uint16_t &data)
basic & | operator<< (const uint16_t data)
basic & | operator>> (uint32_t &data)
basic & | operator<< (const uint32_t data)
basic & | operator>> (uint64_t &data)
basic & | operator<< (const uint64_t data)
basic & | operator>> (float &data)
basic & | operator<< (const float data)
basic & | operator>> (double &data)
basic & | operator<< (const double data)
basic & | operator>> (char &data)
basic & | operator<< (const char data)
template<class _Elem , class _Traits = std::char_traits<_Elem>, class _Ax = std::allocator<_Elem>>
basic & | operator>> (std::basic_string< _Elem, _Traits, _Ax > &data)
template<class T >
basic & | operator<< (const T *data)
template<class _Elem , class _Traits = std::char_traits<_Elem>, class _Ax = std::allocator<_Elem>>
basic & | operator<< (const std::basic_string< _Elem, _Traits, _Ax > &data)
template<class _Ty , class _Alloc = std::allocator<_Ty>>
basic & | operator<< (const std::vector< _Ty, _Alloc > &data)
template<class _Ty , class _Alloc = std::allocator<_Ty>>
basic & | operator>> (std::vector< _Ty, _Alloc > &data)
template<class _Kty , class _Pr = std::less<_Kty>, class _Alloc = std::allocator<_Kty>>
basic & | operator<< (const std::set< _Kty, _Pr, _Alloc > &data)
template<class _Kty , class _Pr = std::less<_Kty>, class _Alloc = std::allocator<_Kty>>
basic & | operator>> (std::set< _Kty, _Pr, _Alloc > &data)
template<class _Kty , class _Pr = std::less<_Kty>, class _Alloc = std::allocator<_Kty>>
basic & | operator<< (const std::multiset< _Kty, _Pr, _Alloc > &data)
template<class _Kty , class _Pr = std::less<_Kty>, class _Alloc = std::allocator<_Kty>>
basic & | operator>> (std::multiset< _Kty, _Pr, _Alloc > &data)
Public Member Functions inherited from stdex::stream::basic_sys
| basic_sys (sys_handle h=invalid_handle, state_t state=state_t::ok)
virtual size_t | read (_Out_writes_bytes_to_opt_(length, return) void *data, size_t length)
| Reads block of data from the stream.
virtual size_t | write (_In_reads_bytes_opt_(length) const void *data, size_t length)
| Writes block of data to the stream.
virtual void | close ()
| Closes the stream.
virtual void | flush ()
| Persists volatile element data.
Public Member Functions inherited from stdex::sys_object
| sys_object (sys_handle h=invalid_handle)
| sys_object (const sys_object &other)
sys_object & | operator= (const sys_object &other)
| sys_object (sys_object &&other) noexcept
sys_object & | operator= (sys_object &&other) noexcept
| operator bool () const noexcept
| Returns true if object is valid.
sys_handle | get () const noexcept
| Returns object handle.

## Static Public Member Functions

static bool | exists (const stdex::schar_t *filename)
| Checks if file/folder/symlink likely exists.
static bool | exists (const stdex::sstring &filename)
| Checks if file/folder/symlink likely exists.
static bool | readonly (const stdex::schar_t *filename)
| Checks if file/folder/symlink is read-only.
static bool | readonly (const stdex::sstring &filename)
| Checks if file/folder/symlink is read-only.

## Additional Inherited Members

Static Protected Member Functions inherited from stdex::sys_object
static void | close (sys_handle h)
| Closes object.
static sys_handle | duplicate (sys_handle h, bool inherit)
| Duplicates given object.
Protected Attributes inherited from stdex::stream::basic
state_t | m_state
Protected Attributes inherited from stdex::sys_object
sys_handle | m_h

## Detailed Description

File-system file.

## Constructor & Destructor Documentation

## file() [1/2]

stdex::stream::file::file | ( | const schar_t * | filename,
|  | int | mode
| ) |  |

inline

Opens file.

Parameters

  [in] | filename | Filename
  [in] | mode | Bitwise combination of mode_t flags

## file() [2/2]

stdex::stream::file::file | ( | const stdex::sstring & | filename,
|  | int | mode
| ) |  |

inline

Opens file.

Parameters

  [in] | filename | Filename
  [in] | mode | Bitwise combination of mode_t flags

## Member Function Documentation

## atime()

virtual time_point stdex::stream::file::atime | ( |  | ) | const

inlinevirtual

Returns file access time.

Reimplemented from stdex::stream::basic_file.

## ctime()

virtual time_point stdex::stream::file::ctime | ( |  | ) | const

inlinevirtual

Returns file creation time.

Reimplemented from stdex::stream::basic_file.

## exists() [1/2]

static bool stdex::stream::file::exists | ( | const stdex::schar_t * | filename | ) |

inlinestatic

Checks if file/folder/symlink likely exists.

Parameters

  [in] | filename | Filename

## exists() [2/2]

static bool stdex::stream::file::exists | ( | const stdex::sstring & | filename | ) |

inlinestatic

Checks if file/folder/symlink likely exists.

Parameters

  [in] | filename | Filename

## lock()

virtual void stdex::stream::file::lock | ( | fpos_t | offset,
|  | fsize_t | length
| ) |  |

inlinevirtual

Locks file section for exclusive access.

Reimplemented from stdex::stream::basic_file.

## mtime()

virtual time_point stdex::stream::file::mtime | ( |  | ) | const

inlinevirtual

Returns file modification time.

Reimplemented from stdex::stream::basic_file.

## open() [1/2]

void stdex::stream::file::open | ( | const schar_t * | filename,
|  | int | mode
| ) |  |

inline

Opens file.

Parameters

  [in] | filename | Filename
  [in] | mode | Bitwise combination of mode_t flags

## open() [2/2]

void stdex::stream::file::open | ( | const stdex::sstring & | filename,
|  | int | mode
| ) |  |

inline

Opens file.

Parameters

  [in] | filename | Filename
  [in] | mode | Bitwise combination of mode_t flags

## readonly() [1/2]

static bool stdex::stream::file::readonly | ( | const stdex::schar_t * | filename | ) |

inlinestatic

Checks if file/folder/symlink is read-only.

For inexisting or inaccessible paths, writeability is assumed.

Parameters

  [in] | filename | Filename

## readonly() [2/2]

static bool stdex::stream::file::readonly | ( | const stdex::sstring & | filename | ) |

inlinestatic

Checks if file/folder/symlink is read-only.

For inexisting or inaccessible paths, writeability is assumed.

Parameters

  [in] | filename | Filename

## seek()

virtual fpos_t stdex::stream::file::seek | ( | foff_t | offset,
|  | seek_t | how = `seek_t::beg`
| ) |  |

inlinevirtual

Seeks to specified relative file position.

Returns
  Absolute file position after seek, or fpos_max if seek failed.

Implements stdex::stream::basic_file.

## set_atime()

virtual void stdex::stream::file::set_atime | ( | time_point | date | ) |

inlinevirtual

Sets file access time.

Reimplemented from stdex::stream::basic_file.

## set_ctime()

virtual void stdex::stream::file::set_ctime | ( | time_point | date | ) |

inlinevirtual

Sets file create time.

Reimplemented from stdex::stream::basic_file.

## set_mtime()

virtual void stdex::stream::file::set_mtime | ( | time_point | date | ) |

inlinevirtual

Sets file modification time.

Reimplemented from stdex::stream::basic_file.

## size()

virtual fsize_t stdex::stream::file::size | ( |  | ) |

inlinevirtual

Returns file size Should the file size cannot be determined, the method returns fsize_max and it does not reset the state to failed.

Implements stdex::stream::basic_file.

## tell()

virtual fpos_t stdex::stream::file::tell | ( |  | ) | const

inlinevirtual

Returns absolute file position in file or fpos_max if fails. This method does not update stream state.

Returns
  Absolute file position or fpos_max if position cannot be determined.

Implements stdex::stream::basic_file.

## truncate()

virtual void stdex::stream::file::truncate | ( |  | ) |

inlinevirtual

Sets file size - truncates the remainder of file content from the current file position to the end of file.

Implements stdex::stream::basic_file.

## unlock()

virtual void stdex::stream::file::unlock | ( | fpos_t | offset,
|  | fsize_t | length
| ) |  |

inlinevirtual

Unlocks file section for exclusive access.

Reimplemented from stdex::stream::basic_file.

The documentation for this class was generated from the following file:

- include/stdex/stream.hpp